Retrieves all attribute set definition from your contact data model.
Code Example
To retrieve all of the attribute set definitions for your account, issue a GET request to the /contacts/v1/attributeSetDefinitions endpoint.
Host: https://YOUR_SUBDOMAIN.rest.marketingcloudapis.com
GET /contacts/v1/attributeSetDefinitions
Content-Type: application/json
Authorization: Bearer YOUR_ACCESS_TOKEN
The response contains information about the attribute sets in your contact data model.
note: The output of this request contains several thousand lines. For a result that's easier to interpret, retrieve the definitions for a specific attribute set by passing its ID. This sample has been shortened.
{
"page": 1,
"pageSize": 50,
"count": 14,
"items": [
{
"id": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"key": "PushDemographics",
"name": {
"value": "MobilePush Demographics"
},
"fullyQualifiedName": "MobilePush Demographics",
"storageLogicalType": "PushAttributes",
"isRoot": false,
"isSendable": true,
"categoryID": 685512,
"isShared": false,
"dataRetentionProperties": {
"setDefinitionID": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"isRowBasedRetention": false,
"isResetRetentionPeriodOnImport": false,
"isDeleteAtEndOfRetentionPeriod": false
},
"sendAttributeStorageName": "_ContactID",
"sendContactKeyStorageName": "_SubscriberID",
"isEvent": false,
"relationships": [
{
"id": "33f35cd5-f1c1-e311-a1e0-e83935a85380",
"leftItem": {
"relationshipType": "AttributeGroup",
"identifier": "30f35cd5-f1c1-e311-a1e0-e83935a85380",
"cardinality": "One",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"rightItem": {
"relationshipType": "AttributeSet",
"identifier": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"cardinality": "Many",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"relationshipAttributes": [
{
"leftAttributeID": "487b6afa-7e4c-e311-8052-e83935a85380",
"rightAttributeID": "16f35cd5-f1c1-e311-a1e0-e83935a85380",
"leftConnectingID": {
"identifierType": "FullyQualifiedName"
},
"rightConnectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
}
],
"isSystemDefined": false,
"leftRelationshipReferenceType": "CustomerData",
"leftRelationshipIDs": [
{
"type": "int16",
"value": "2"
}
],
"canModify": false,
"canRemove": false,
"links": {},
"objectState": "Created"
},
{
"id": "c0453e25-1167-e411-92ad-e83935a85380",
"leftItem": {
"relationshipType": "AttributeSet",
"identifier": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"cardinality": "One",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"rightItem": {
"relationshipType": "AttributeSet",
"identifier": "b7453e25-1167-e411-92ad-e83935a85380",
"cardinality": "Many",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"relationshipAttributes": [
{
"leftAttributeID": "12f35cd5-f1c1-e311-a1e0-e83935a85380",
"rightAttributeID": "b8453e25-1167-e411-92ad-e83935a85380",
"leftConnectingID": {
"identifierType": "FullyQualifiedName"
},
"rightConnectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
{
"leftAttributeID": "19f35cd5-f1c1-e311-a1e0-e83935a85380",
"rightAttributeID": "b9453e25-1167-e411-92ad-e83935a85380",
"leftConnectingID": {
"identifierType": "FullyQualifiedName"
},
"rightConnectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
}
],
"isSystemDefined": false,
"leftRelationshipIDs": [],
"canModify": false,
"canRemove": false,
"links": {},
"objectState": "Created"
},
{
"id": "d4453e25-1167-e411-92ad-e83935a85380",
"leftItem": {
"relationshipType": "AttributeSet",
"identifier": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"cardinality": "One",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"rightItem": {
"relationshipType": "AttributeSet",
"identifier": "ca453e25-1167-e411-92ad-e83935a85380",
"cardinality": "Many",
"connectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
"relationshipAttributes": [
{
"leftAttributeID": "12f35cd5-f1c1-e311-a1e0-e83935a85380",
"rightAttributeID": "cb453e25-1167-e411-92ad-e83935a85380",
"leftConnectingID": {
"identifierType": "FullyQualifiedName"
},
"rightConnectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
},
{
"leftAttributeID": "19f35cd5-f1c1-e311-a1e0-e83935a85380",
"rightAttributeID": "ce453e25-1167-e411-92ad-e83935a85380",
"leftConnectingID": {
"identifierType": "FullyQualifiedName"
},
"rightConnectingID": {
"identifierType": "FullyQualifiedName"
},
"objectState": "Created"
}
],
"isSystemDefined": false,
"leftRelationshipIDs": [],
"canModify": false,
"canRemove": false,
"links": {},
"objectState": "Created"
}
],
"attributes": [
{
"id": "12f35cd5-f1c1-e311-a1e0-e83935a85380",
"key": "PushAppID",
"name": {
"value": "Application"
},
"storageName": "_APID",
"dataType": "Text",
"isPrimaryKey": true,
"isNullable": false,
"isReadOnly": true,
"displayOrder": 2,
"ranges": [],
"description": "",
"length": 38,
"dataSourceID": 3,
"restrictedValues": [],
"restrictionLookupListID": 4,
"customerDataID": 7,
"fullyQualifiedName": "MobilePush Demographics.Application",
"parentId": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"isSystemDefined": true,
"isIdentityValue": false,
"isHidden": false,
"isUpdateable": false,
"parentType": "Set",
"dataSourceName": {},
"links": {},
"objectState": "Created"
},
{
"id": "13f35cd5-f1c1-e311-a1e0-e83935a85380",
"key": "Badge",
"name": {
"value": "Badge"
},
"storageName": "_Badge",
"dataType": "Number",
"isPrimaryKey": false,
"isNullable": true,
"isReadOnly": true,
"displayOrder": 3,
"ranges": [],
"description": "",
"dataSourceID": 3,
"restrictedValues": [],
"fullyQualifiedName": "MobilePush Demographics.Badge",
"parentId": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"isSystemDefined": true,
"isIdentityValue": false,
"isHidden": false,
"isUpdateable": false,
"parentType": "Set",
"dataSourceName": {},
"links": {},
"objectState": "Created"
},
{
"id": "14f35cd5-f1c1-e311-a1e0-e83935a85380",
"key": "Channel",
"name": {
"value": "Channel"
},
"storageName": "_Channel",
"dataType": "Text",
"isPrimaryKey": false,
"isNullable": true,
"isReadOnly": true,
"displayOrder": 4,
"ranges": [],
"description": "",
"length": 20,
"dataSourceID": 3,
"restrictedValues": [],
"fullyQualifiedName": "MobilePush Demographics.Channel",
"parentId": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"isSystemDefined": true,
"isIdentityValue": false,
"isHidden": false,
"isUpdateable": false,
"parentType": "Set",
"dataSourceName": {},
"links": {},
"objectState": "Created"
},
{
"id": "15f35cd5-f1c1-e311-a1e0-e83935a85380",
"key": "City",
"name": {
"value": "City"
},
"storageName": "_City",
"dataType": "Text",
"isPrimaryKey": false,
"isNullable": true,
"isReadOnly": false,
"displayOrder": 5,
"ranges": [],
"description": "",
"length": 200,
"dataSourceID": 3,
"restrictedValues": [],
"fullyQualifiedName": "MobilePush Demographics.City",
"parentId": "10f35cd5-f1c1-e311-a1e0-e83935a85380",
"isSystemDefined": false,
"isIdentityValue": false,
"isHidden": false,
"isUpdateable": false,
"parentType": "Set",
"dataSourceName": {},
"links": {},
"objectState": "Created"
},
...
],
"canAddValues": true,
"isSystemDefined": true,
"canRemove": false,
"canModify": false,
"isReadOnly": false,
"applicationID": "2051892d-5de2-4ecf-98af-8ca9a40d2c9c",
"applicationKey": "com.exacttarget.mobilepush",
"links": {},
"objectState": "Created"
},
...
],
"links": {
"self": {
"href": "/v1/attributeSetDefinitions"
},
"schema": {
"href": "/v1/schema"
}
},
"requestServiceMessageID": "57d67e08-6e4c-4e06-98e6-f0993725c1ae",
"responseDateTime": "2024-09-05T14:09:16.7400199-06:00",
"resultMessages": [],
"serviceMessageID": "eacba18f-c31c-4619-bc05-522d72e99ee0"
}